<template>
    <node-view-wrapper contenteditable="false" draggable="true" style="outline:none;">
        <div ref="outer" class="the-editor-image-resizer">
        <div class="the-editor-image-resizer-box" :class="{'ProseMirror-selectednode': selected}" :style="widthStyle">
            <div class="the-editor-image-resizer-handle" style="left:0" aria-label="resize handle" title="drag to resize" @mousedown="startDrag">
            </div>
            <figure class="the-editor-image-figure" v-bind="extension.options.FigureHTMLAttributes">
            <span class="width-label" aria-label="width">{{width}}%</span>
            <img v-if="imgSrc.length" ref="img" :src="imgSrc" :alt="node?.attrs.alt" :style="imageStyle" draggable="true" data-drag-handle>
            <textarea placeholder="(required!) alt text / image description" rows="3" v-model="alt" required style="width: 100%" aria-label="Alt Text"></textarea>
            <figcaption>
                <div style="display:flex;justify-content: center; align-items:baseline; flex-wrap: wrap;">
                    <label style="margin-right: 1rem; font-weight: bold;">Caption:</label>
                    <input id="c" placeholder="(optional) image caption / title" v-model="caption" style="flex-grow:1;" aria-label="Caption/Title">
                </div>
            </figcaption>
            </figure>
            <div class="the-editor-image-resizer-handle" style="right:0" aria-label="resize handle" title="drag to resize" @mousedown="startDrag"></div>
        </div>  
        </div>
    </node-view-wrapper>
</template>


<script lang="ts" setup>
import { NodeViewWrapper, nodeViewProps } from '@tiptap/vue-3';
import { mergeAttributes } from '@tiptap/core';
import {computed, ref, watch} from 'vue'
const props = defineProps(nodeViewProps)
const outer = ref<HTMLElement>()


const getImgSrc = async () => {
    if (!!props.extension.options.renderSrc) {
        imgSrc.value = await props.extension.options.renderSrc(
            props.node.attrs.src
        )
        return
    }
    imgSrc.value = props.node.attrs.src
}
const imgSrc = ref('')

watch(()=>props.node?.attrs.src, getImgSrc, {immediate: true})
getImgSrc()

const caption = computed({
    get: ()=>props.node?.attrs.caption,
    set: (s:string)=>props.updateAttributes!({caption: s})
})
const alt = computed({
    get: ()=>props.node?.attrs.alt,
    set: (s:string)=>props.updateAttributes!({alt: s})
})
const width = computed({
    get: ()=>props.node?.attrs.width,
    set: (s:number)=>props.updateAttributes!({width: s})
})

const widthStyle = computed(()=>`width: ${width.value}%`)

const imageStyle = computed(()=>mergeAttributes(
    {style: props.extension.options.ImageHTMLAttributes.style},
).style)

const doDrag = (e:MouseEvent) => {
    // get left offset of parent
    //const parentOffset = outer.value!.offsetLeft
    const parentOffset =outer.value!.getBoundingClientRect().left;
    const parentWidth = outer.value!.clientWidth / 2
    // get mouse location (only works for RIGHT right now!)
    let point = Math.abs(e.clientX - parentWidth - parentOffset)
    const percent = Math.min(100, Math.max(Math.floor(point / parentWidth * 100), 10))
    // Clamp to 100% and 0%
    
    width.value = percent
}

const stopDrag = () => {
    window.removeEventListener('mousemove', doDrag)
    window.removeEventListener('mouseup', stopDrag)
}

const startDrag = () => {
    window.addEventListener('mousemove', doDrag)
    window.addEventListener('mouseup', stopDrag)    
}

</script>

<style scoped>

.the-editor-image-resizer{
    width: 100%;
}

.the-editor-image-resizer-box{
    position: relative;
    margin: 0 auto;
    border: 1px dashed #666;
}

.the-editor-image-resizer-handle{
    width: 12px;
    cursor: ew-resize;
    position: absolute;
    top: 0;
    height: 100%;
    z-index: 10;
}
.width-label {
    position: absolute; /* Position the pseudo-element absolutely within the container */
    top: 0; /* Align the pseudo-element to the top of the container */
    right: 0; /* Align the pseudo-element to the right of the container */
    font-size: 12px; /* Adjust the font size as needed */
    color: #fff; /* Adjust the text color as needed */
    background-color: rgba(0, 0, 0, 0.5); /* Optional: Add a background for better readability */
    padding: 2px 5px; /* Add some padding around the text */
    border-bottom-left-radius: 25%; /* Optional: Add rounded corners */
   }
</style>

